//获取应用实例
const app = getApp();
var token = wx.getStorageSync('token');
var http = require("../../utils/config.js");
const util = require('../../utils/utils.js')
Page({
  data: {
    markers: [], //显示单车、停车的P
    polygons: [], //区域
    longitude: '113.779801',
    latitude: '34.753993',
    height1: '', //兼容自定义导航栏的高度
    polygons1: [], //可骑行区域 先用这个变量代表
    controls: [], //地图上当前定位的箭头                     
  },
  onLoad: function (query) {
    var that = this;
    this.location();
    wx.setNavigationBarTitle({
      title:'附近车辆'
  })
  },
  home: function () {
    //请求首页接口和一些设置。
    var that = this;
    if (that.data.longitude != '' && that.data.latitude != '' && token != '') {
      //116.411027
      var data = {
        'lat': that.data.latitude,
        'lng': that.data.longitude
      }
      wx.request({
        url: http.url + '/pages/home?include=setting',
        method: 'POST',
        header: {
          'content-type': 'application/x-www-form-urlencoded',
          Authorization: token
        },
        data: data,
        success: function (res) {
          console.log(res)
          if (res.statusCode == 200) {
            var data = res.data;
            console.log(data)
            if (data.points != []) {
              that.setData({
                id: data.id,
                polygons1: that.data.polygons.concat(data),
                polygons: []
              })
              if (!data.id) return
              that.setData({
                polygons: that.data.polygons.concat(data)
              })
            }
            if (res.data.status_code == 423) {
              wx.getLocation({
                success: function (res) {
                  wx.showModal({
                    title: '提示',
                    content: '您附近暂无运营区域~',
                    showCancel: false
                  })
                },
                fail: function (err) {
                  that.setData({
                    location: true
                  })
                }
              })
            }
          }
        }
      })
    }
  },
  nearbyCars: function () {
    //附近的车
    var that = this;
    that.setData({
      markers: []
    })
    var data = {
      "lat": that.data.latitude,
      "lng": that.data.longitude
    }
    app.request("/bikes", data, "POST").then(res => {
      console.log(res)
      if (res.statusCode == 200) {
        var makers = res.data
        if (makers == '') {
          wx.showToast({
            title: '附近暂无车辆',
            icon: 'none'
          })
          that.setData({
            markers: []
          })
        } else {
          for (var i = 0; i < makers.length; i++) {
            var iconPath = makers[i].img;
            makers[i].iconPath = 'http://resource.weilaigo.l4j.cn/bluebike.png';
            makers[i].width = 24;
            makers[i].height = 28;
            makers[i].zIndex = 1111;
            makers[i].id = makers[i].bike_no;
          }
          that.setData({
            markers: makers
          })
          console.log(that.data.markers)
        }
      }
    })
  },
  onShow: function () {
    var that = this;
    token = wx.getStorageSync('token')
  },
  onReady: function () {

  },
  location: function () {
    //获取当前经纬度 如果未授权让用户去授权
    var that = this;
    wx.showLoading({
      title: '定位中...',
      mask: true
    })
    wx.getLocation({
      type: 'gcj02',
      success: (res) => {
        console.log('经纬度为：+++++++++++++++++++++' + res.latitude + '++++++++' + res.longitude)
        var latitude = res.latitude
        var longitude = res.longitude
        that.setData({
          longitude: longitude,
          latitude: latitude
        })
        that.home()
        that.nearbyCars()
        wx.hideLoading()
      },
      fail: function () {
        wx.hideLoading()
        wx.getSetting({
          success: function (res) {
            console.log(res)
            var statu = res.authSetting;
            if (statu['scope.userLocation'] == false) {
              that.setData({
                background: true,
                location: true
              })
            }
          }
        })
      }
    })
  },
  onHide: function () {
    this.setData({
      bike_no: undefined,
      background: false,
      bluetooth: false,
      location: false,
      scanfail: false,
      over1: false
    })
  },
  onShareAppMessage: function () {
    
  }
})