var app = getApp()
import {
  BluetoothManager,
  BtErrorCode
} from '../../service/BlueMgr'
const bluM = new BluetoothManager;
const util = require('../../utils/utils.js');
var interval;
Page({
  data: {
    currentTab: 0, //日租月租顶部切换
    zoom: 14, //地图缩放比例
    polygons: [], //骑行区域
    setting: {}, //区域配置
    markers: [], //中心点坐标
    longitude: '',
    latitude: '',
    jifei: true, //是否展示计费规则
    code: '',
    arr: [],
    screenHeight: '',
    show: false,
    popShow: false, //用车提醒
    time: 5,
    tapShow: false,
    setting: wx.getStorageSync('setting'),
    footer: [],
    chooseSize: false,
    mid: [],
    animationData: {},
    chooseSize: false,
    animationData1: {},
    arrowDown: '',
    midbolear: '',
    site: {
      latitude: '0',
      longitude: '0'
    }
  },
  chooseSezi: function (e) {
    // 用that取代this，防止不必要的情况发生
    var that = this;
    // 创建一个动画实例
    var animation = wx.createAnimation({
      // 动画持续时间
      duration: 600,
      // 定义动画效果，当前是匀速
      timingFunction: 'linear'
    })
    // 将该变量赋值给当前动画
    that.animation = animation
    // 先在y轴偏移，然后用step()完成一个动画
    animation.translateY(300).step()
    // 用setData改变当前动画
    that.setData({
      // 通过export()方法导出数据
      animationData1: animation.export(),
      // 改变view里面的Wx：if
      chooseSize: true
    })
    // 设置setTimeout来改变y轴偏移量，实现有感觉的滑动
    setTimeout(function () {
      animation.translateY(0).step()
      that.setData({
        animationData1: animation.export()
      })
    }, 100)
    var query = wx.createSelectorQuery();
    query.select('.choose').boundingClientRect();
    query.exec(function (res) {
      console.log(res)
      that.setData({
        arrowDown: res[0].height + 15
      })
    })
  },
  //单次用车和日租用车切换
  chanfTab: function (e) {
    console.log(e,'点击切换')
    let tab=e.target.dataset.value
    this.setData({
      currentTab:tab
    })
  },
  hideModal: function (e) {
    var that = this;
    var animation = wx.createAnimation({
      duration: 800,
      timingFunction: 'linear'
    })
    that.animation = animation
    animation.translateY(300).step()
    that.setData({
      animationData1: animation.export()

    })
    setTimeout(function () {
      animation.translateY(0).step()
      that.setData({
        animationData1: animation.export(),
        chooseSize: false
      })
    }, 700)
  },
  ads: function () {
    var that = this;
    var area_id = ''
    if (wx.getStorageSync('home').id != undefined) {
      area_id = wx.getStorageSync('home').id
    } else {
      area_id = 0
    }
    // var data = {
    //   'position': "['header','mid']",
    //   'area_id': area_id
    // }
    app.request("/ads?area_id=" + area_id + "&position[]=mid&position[]=header&position[]=footer", '', "GET").then(res => {
      // console.log(res)
      if (res.statusCode == 200) {
        that.setData({
          ads: res.data.header
        })
        if (res.data.mid == undefined || res.data.mid == 'undefined') {

        } else {
          that.setData({
            mid: res.data.mid
          })
        }
        if (res.data.footer == undefined || res.data.footer == 'undefined') {

        } else {
          that.setData({
            footer: res.data.footer
          })
        }
      }
    }).catch(err => {
      console.log(err)
    })
  },
  onLoad: function (options) {
    console.log(options)
    var that = this;
    wx.showLoading({
      title: '加载中...',
      mask: true
    })
    if (wx.getStorageSync('popShow') != true) {
      that.setData({
        popShow: true
      })
    } else {
      that.setData({
        popShow: false
      })
    }
    interval = setInterval(function () {
      var time = that.data.time - 1;
      that.setData({
        time
      })
      if (time <= 0) {
        clearInterval(interval)
        that.setData({
          tapShow: true
        })
      }
    }, 1000)
    this.setData({
      screenHeight: app.globalData.screenHeight
    })
    app.request('/bike/' + options.code, '', 'GET').then(res => {
      console.log(res)
      200 == res.statusCode && that.setData({
        arr: res.data
      }), wx.hideLoading()
      if (res.statusCode == 200) {
        wx.setStorageSync('home', res.data.area)
        wx.setStorageSync('setting', res.data.area.setting)
        this.setData({
          polygons: that.data.polygons.concat(res.data.area),
          longitude: res.data.area.area_centre.longitude,
          latitude: res.data.area.area_centre.latitude,
          setting: res.data.area.setting,
          markers: that.data.markers.concat(res.data.area.area_centre),
        })
        this.getStopArea(res.data.area.id)
        if (res.data.is_link == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子已下线请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.put_status == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子还未投放请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_low_battery_power == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子电量过低请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_trouble == 1) {
          wx.showModal({
            title: '提示',
            content: '当前车子出现故障请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_riding == 1) {
          wx.showModal({
            title: '提示',
            content: '当前车子正在骑行请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else {
          bluM.connectDeivece(res.data.box_no).then(res => {
            //蓝牙连接成功 是否用蓝牙
          }, rej => {
            console.log(rej)
            //蓝牙连接异常
            wx.getBluetoothAdapterState({
              success(res) {
                console.log(res)
                if (res.available == false) {
                  wx.showModal({
                    title: '提示',
                    content: '手动开启蓝牙体验快速开锁~',
                    showCancel: false
                  })
                }
              }
            })
          })
        }
      }
    })
    that.setData({
      code: options.code
    })
    setTimeout(() => {
      that.ads();
    }, 500);
  },
  rules: function () {
    wx.navigateTo({
      url: "/pages/accounting_rules/accounting_rules",
    })
  },
  view_area: function () {
    wx.navigateTo({
      url: '/pages/navigation/navigation',
    })
  },
  closePop() {
    this.setData({
      popShow: false,
    })
    wx.setStorageSync('popShow', true)
  },
  repair: util.throttle(function () {
    wx.navigateTo({
      url: '../repair/repair?bike_id=' + this.data.code
    })
  }, 1000),
  openBike() {
    var that = this;
    wx.showLoading({
      title: '开锁中...',
      mask: true
    })
    // wx.getLocation({
    //   type: 'gcj02',
    //   success: function (res) {
    //     console.log(res)
    if (that.data.site.latitude == 0) {
      wx.showToast({
        title: '请确保手机定位打开后再试~',
        icon: 'none'
      })
      return
    }
    var data = {
      bike_no: that.data.code,
      // lat: res.latitude,
      // lng: res.longitude,
      lat: that.data.site.latitude,
      lng: that.data.site.longitude,
      area_id: wx.getStorageSync('home').id,
    }
    console.log(data, '+++++++')
    if (app.globalData.req) {
      app.request('/bike/open-lock', data, 'POST', app.globalData.req).then(res => {
        console.log(res)
        if (res.statusCode == 200) {
          bluM.connectDeivece(that.data.arr.box_no).then(res => {
            console.log('连接成功')
            bluM.unlockBike()
          })
          wx.reLaunch({
            url: '../riding/riding?order=' + res.data.no + '&code=' + that.data.code + '&box_no=' + that.data.arr.box_no + '&time=true',
          })
          wx.hideLoading()
        }
      })
    } else {
      wx.showToast({
        title: '您的操作过于频繁，请稍后再试~',
        icon: 'none'
      })
    }

    //   },
    // })
  },
  start: util.throttle(function () {
    console.log('123')
    var that = this;
    wx.getLocation({
      success: function (res) {
        wx.requestSubscribeMessage({
          tmplIds: ['CBp8jWZHVOQBIB7_n4EHuDv3ik12gOvlaXsOG2U0dPc', 'rV85SkGp7Q508xXz45ycQw8nTN_2VEB7m_GhR-WrCDY'],
          success(res) {
            console.log(res)
          },
          fail: function (err) {
            console.log(err)
          },
          complete: function () {
            that.openBike()
          }
        })
      },
      fail: function (err) {
        wx.showModal({
          title: '提示',
          content: '请打开位置权限~',
          cancelText: "去设置",
          confirmText: "已打开",
          success: function (resp) {
            if (resp.cancel) {
              wx.openSetting({
                success: function (res) {
                  // console.log(res)
                  // console.log(res.authSetting)
                }
              })
            }
          }
        })
      }
    })

  }, 1000),
  rent_start: function () {
    this.setData({
      show: true
    })
  },
  // 返回
  backIndex: function () {
    this.setData({
      show: false
    })
  },
  rent_startBike() {
    var that = this;
    wx.getLocation({
      success: function (res) {
        console.log(res)
        if (app.globalData.req) {
          var data = {
            'type': 'D',
            'bike_no': that.data.code,
            'area_id': wx.getStorageSync('home').id,
            'lat': res.latitude,
            'lng': res.longitude
          }
          app.request('/rent/store-order', data, 'POST', app.globalData.req).then(res => {
            console.log(res)
            if (res.statusCode == 200) {
              console.log(res.data.nonceStr == undefined)
              if (res.data.nonceStr == undefined) {
                wx.reLaunch({
                  url: '/pages/daily_riding/daily_riding?order=' + res.data.no,
                })
              } else {
                wx.reLaunch({
                  url: '/pages/daily_riding/daily_riding?order=' + res.data.no,
                })
              }
            }
          })
        } else {
          wx.showToast({
            title: '您的操作过于频繁，请稍后再试~',
            icon: 'none'
          })
        }

      },
    })
  },
  btn: util.throttle(function () {
    var that = this;
    wx.requestSubscribeMessage({
      tmplIds: ['ahWdpxZJ48d3K9ZxnrNvXLvx7NEI2j-Ckp5LODNlYNU', 'N7etCOUMjvsyGxx0JroDfMwEmi8daKC20czG6aqkpPc'],
      success(res) {
        console.log(res)

      },
      fail: function (err) {
        console.log(err)
      },
      complete: function () {
        that.rent_startBike()
      }
    })
    // that.rent_startBike()
    // wx.getLocation({
    //   success: function (res) {

    //   },
    //   fail: function (err) {
    //     wx.showModal({
    //       title: '提示',
    //       content: '请打开位置权限~',
    //       cancelText: "去设置",
    //       confirmText: "已打开",
    //       success: function (resp) {
    //         if (resp.cancel) {
    //           wx.openSetting({
    //             success: function (res) {
    //               // console.log(res)
    //               // console.log(res.authSetting)
    //             }
    //           })
    //         }
    //       }
    //     })
    //   }
    // })

  }, 1000),
  // 换一辆车扫码开锁
  sweep_code() {
    var that = this
    wx.scanCode({
      onlyFromCamera: true,
      success: function (res) {
        // console.log(res)
        var index = res.result.lastIndexOf("\=");
        var code = res.result.substring(index + 1, res.result.length);
        console.log(code.length)
        if (code.length == 11) {
          console.log(code, 'code')
          that.openBikeMethods(code)
          that.setData({
            code: code,
          })
        } else {
          wx.showToast({
            title: '请扫描正确的二维码！',
            icon: 'none'
          })
        }

      },
      fail: function (err) {
        console.log(err)
        that.setData({
          background: true,
          scanfail: true,
          over1: true
        })
      }
    })
  },
  // 开锁方法
  openBikeMethods(code) {
    var that = this
    app.request('/bike/' + code, '', 'GET').then(res => {
      console.log(res)
      200 == res.statusCode && that.setData({
        arr: res.data
      }), wx.hideLoading()
      if (res.statusCode == 200) {
        this.getStopArea(res.data.area.id)
        wx.setStorageSync('home', res.data.area)
        wx.setStorageSync('setting', res.data.area.setting)
        this.setData({
          polygons: that.data.polygons.concat(res.data.area),
          longitude: res.data.area.area_centre.longitude,
          latitude: res.data.area.area_centre.latitude,
          setting: res.data.area.setting,
          markers: that.data.markers.concat(res.data.area.area_centre),
        })

        if (res.data.is_link == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子已下线请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.put_status == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子还未投放请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_low_battery_power == 0) {
          wx.showModal({
            title: '提示',
            content: '当前车子电量过低请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_trouble == 1) {
          wx.showModal({
            title: '提示',
            content: '当前车子出现故障请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else if (res.data.is_riding == 1) {
          wx.showModal({
            title: '提示',
            content: '当前车子正在骑行请换辆车子骑行吧~',
            showCancel: false,
            success: function (res) {
              if (res.confirm) {
                wx.navigateBack()
              }
            }
          })
          return;
        } else {
          bluM.connectDeivece(res.data.box_no).then(res => {
            //蓝牙连接成功 是否用蓝牙
          }, rej => {
            console.log(rej)
            //蓝牙连接异常
            wx.getBluetoothAdapterState({
              success(res) {
                console.log(res)
                if (res.available == false) {
                  wx.showModal({
                    title: '提示',
                    content: '手动开启蓝牙体验快速开锁~',
                    showCancel: false
                  })
                }
              }
            })
          })
        }
      }
    })
  },
  getStopArea(area_id) {
    var that = this
    var data1 = {
      'area_id': area_id
    }
    app.request('/parking/stop-sites', data1, 'GET').then(res => {
      // console.log(res)
      if (res.statusCode == 200) {
        var data = res.data
        that.setData({
          polygons: that.data.polygons.concat(data.polygons),
        })
      }
    })
  },
  // 点击计费规则按钮
  showJfei() {
    this.setData({
      jifei: !this.data.jifei
    })
  },
  over: function () {
    this.setData({
      show: false
    })
  },
  onReady: function () {

  },
  onShow: function () {
    wx.startLocationUpdate({
      success: (res) => {
        console.log(res)
      }
    })

    wx.onLocationChange((res) => {
      this.setData({
        site: res
      })
    })
    this.setData({
      setting: wx.getStorageSync('setting')
    })
  },
  onHide: function () {
    clearInterval(interval)
    this.setData({
      time: 5
    })
    wx.offLocationChange()
    wx.stopLocationUpdate({
      success: (res) => {
        console.log(res, "+++>")
      },
    })
  },
  onUnload: function () {
    clearInterval(interval)
    this.setData({
      time: 5
    })
  },
  //用户隐私协议
	// 同意
	agree(e) {
    wx.getLocation({
      type: 'gcj02',
      success: (res) => {
        console.log('经纬度为：+++++++++++++++++++++' + res.latitude + '++++++++' + res.longitude)
        var latitude = res.latitude
        var longitude = res.longitude
        that.setData({
          longitude: longitude,
          latitude: latitude
        })
      },
      fail: function (err) {
        console.log(err)
      }
    })
	},
	//不同意
	disagree(e) {
		console.log("用户拒绝隐私授权, 未同意过的隐私协议中的接口将不能调用")
		// wx.exitMiniProgram()
	},
  onPullDownRefresh: function () {

  },
  onReachBottom: function () {

  },
  onShareAppMessage: function () {

  }
})